diff -Nur linux-2.4.30/drivers/sound/au1550_i2s.c linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s.c
--- linux-2.4.30/drivers/sound/au1550_i2s.c	2005-01-19 15:10:04.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s.c	2005-05-12 18:01:29.000000000 +0200
@@ -5,20 +5,34 @@
  * Copyright 2004 Embedded Edge, LLC
  *	dan@embeddededge.com
  *
- * So, I was stupid.....Although this is an I2S interface, it still uses
- * the PSC for communication.  The existing au1550_psc.c should have been
- * called au1550_ac97.c or something.  Not going to rename anything now.
+ * Modified for platform independence -- 5/2/2005
+ *  Chris Gray (chris.gray@amd.com)
  *
- * Mostly copied from the au1550_psc.c driver and some from the
- * PowerMac dbdma driver.
- * We assume the processor can do memory coherent DMA.
+ * This module was reworked to support some of the various hw
+ * platforms that use Au1550/Au1200 and I2S codecs. Most of
+ * the Wolfson CODECs I have encountred do not implement readable
+ * registers. Because of this, I implemented local copy of hw
+ * mixer settings. Another drawback is that I2S will often mux
+ * inputs to ADC. 
+ *
+ * Anyway, because of the limitations and "funkiness" of I2S, I
+ * created another file for platform specific implementation. I 
+ * I gave it the name au1550_i2s_hw.c, for the lack of creativity.
+ *
+ * Mostly copied from the au1550_psc.c.
  *
  * The SMBus (I2C) is required for the control of the codec.  It
  * appears at I2C address 0x36 (I2C binary 0011011).  The Pb1550
  * uses the Wolfson WM8731 codec, which is controlled over the I2C.
+ * 
+ * Pb/Db1550 Pb/Db1200 Notes:
  * It's connected to a 12MHz clock, so we can only reliably support
  * 96KHz, 48KHz, 32KHz, and 8KHz data rates.  The framework for variable
- * rate audio is in place, but we currently force it to 48KHz.
+ * rate audio is in place, but we currently force it to 48KHz. This
+ * is only true of the PSC is running as the I2S Master.
+ * In the au1550_i2s_hw.c file I configure the CODEC to run as 
+ * I2S Master while the Au1xxx device is slave running in slave mode
+ * (SERCLK). We can now support any sample rate the CODEC supports.
  *
  *  This program is free software; you can redistribute  it and/or modify it
  *  under  the terms of  the GNU General  Public License as published by the
@@ -40,7 +54,9 @@
  *  with this program; if not, write  to the Free Software Foundation, Inc.,
  *  675 Mass Ave, Cambridge, MA 02139, USA.
  *
+ *
  */
+
 #include <linux/version.h>
 #include <linux/module.h>
 #include <linux/string.h>
@@ -62,49 +78,32 @@
 #include <asm/uaccess.h>
 #include <asm/hardirq.h>
 #include <asm/au1000.h>
-#include <asm/pb1550.h>
+
 #include <asm/au1xxx_psc.h>
 #include <asm/au1xxx_dbdma.h>
 
-#undef OSS_DOCUMENTED_MIXER_SEMANTICS
-
-#define AU1550_MODULE_NAME "Au1550 i2s audio"
-#define PFX AU1550_MODULE_NAME
+#include "au1550_i2s.h"
 
-/* Define this if you want to try running at the 44.1 KHz rate.
- * It's just a little off, I think it's actually 44117 or something.
- * I did this for debugging, since many programs, including this
- * driver, will try to upsample from 44.1 to 48 KHz.
- * Seems to work well, we'll just leave it this way.
- */
-#define TRY_441KHz
+#undef OSS_DOCUMENTED_MIXER_SEMANTICS
 
-#ifdef TRY_441KHz
-#define SAMP_RATE	44100
-#else
-#define SAMP_RATE	48000
-#endif
+static int      vra = 0;
 
 /* The number of DBDMA ring descriptors to allocate.  No sense making
  * this too large....if you can't keep up with a few you aren't likely
  * to be able to with lots of them, either.
+ *
+ * CTG -- by cranking these up I was able to play 88200 correctly. 4/26/05
  */
-#define NUM_DBDMA_DESCRIPTORS 4
-
-#define err(format, arg...) printk(KERN_ERR PFX ": " format "\n" , ## arg)
-#define info(format, arg...) printk(KERN_INFO PFX ": " format "\n" , ## arg)
+#define NUM_DBDMA_DESCRIPTORS 8
+#define MIN_Q_COUNT		4
 
-/* Boot options
- * 0 = no VRA, 1 = use VRA if codec supports it
- * The framework is here, but we currently force no VRA.
- */
-static int      vra = 0;
 MODULE_PARM(vra, "i");
 MODULE_PARM_DESC(vra, "if 1 use VRA if codec supports it");
 
 static struct au1550_state {
 	/* soundcore stuff */
 	int             dev_audio;
+	int				dev_mixer;
 
 	spinlock_t		lock;
 	struct semaphore	open_sem;
@@ -112,7 +111,12 @@
 	mode_t			open_mode;
 	wait_queue_head_t	open_wait;
 	int			no_vra;
-	volatile psc_i2s_t	*psc_addr;
+	struct i2s_hw	* i2s;
+
+	int level_line;
+	int level_mic;
+	int level_left;
+	int level_right;
 
 	struct dmabuf {
 		u32		dmanr;
@@ -195,88 +199,181 @@
 	}
 }
 
-/* Just a place holder.  The Wolfson codec is a write only device,
- * so we would have to keep a local copy of the data.
- */
-#if 0
-static u8
-rdcodec(u8 addr)
+static int
+au1550_open_mixdev(struct inode *inode, struct file *file)
 {
-	return 0  /* data */;
+	file->private_data = &au1550_state;
+	return 0;
 }
-#endif
 
+static int
+au1550_release_mixdev(struct inode *inode, struct file *file)
+{
+	return 0;
+}
 
-static void
-wrcodec(u8 ctlreg, u8 val)
+static int
+au1550_ioctl_mixdev(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
 {
-	int	rcnt;
-	extern int pb1550_wm_codec_write(u8 addr, u8 reg, u8 val);
+	struct au1550_state *s = (struct au1550_state *)file->private_data;
 
-	/* The codec is a write only device, with a 16-bit control/data
-	 * word.  Although it is written as two bytes on the I2C, the
-	 * format is actually 7 bits of register and 9 bits of data.
-	 * The ls bit of the first byte is the ms bit of the data.
-	 */
-	rcnt = 0;
-	while ((pb1550_wm_codec_write((0x36 >> 1), ctlreg, val) != 1) 
-							&& (rcnt < 50)) {
-		rcnt++;
-#if 0
-		printk("Codec write retry %02x %02x\n", ctlreg, val);
-#endif
+	int i, val = 0;
+
+	if (cmd == SOUND_MIXER_INFO) {
+		mixer_info info;
+		strncpy(info.id, s->i2s->name, sizeof(info.id));
+		strncpy(info.name, s->i2s->name, sizeof(info.name));
+		info.modify_counter = 0;
+		if (copy_to_user((void *)arg, &info, sizeof(info)))
+			return -EFAULT;
+		return 0;
 	}
+	if (cmd == SOUND_OLD_MIXER_INFO) {
+		_old_mixer_info info;
+		strncpy(info.id, s->i2s->name, sizeof(info.id));
+		strncpy(info.name, s->i2s->name, sizeof(info.name));
+		if (copy_to_user((void *)arg, &info, sizeof(info)))
+			return -EFAULT;
+		return 0;
+	}
+
+	if (_IOC_TYPE(cmd) != 'M' || _SIOC_SIZE(cmd) != sizeof(int))
+		return -EINVAL;
+
+	if (cmd == OSS_GETVERSION)
+		return put_user(SOUND_VERSION, (int *)arg);
+
+	if (_SIOC_DIR(cmd) == _SIOC_READ) {
+		switch (_IOC_NR(cmd)) {
+		case SOUND_MIXER_RECSRC: /* give them the current record src */
+			val = 0;
+			/*
+			if (!codec->recmask_io) {
+				val = 0;
+			} else {
+				val = codec->recmask_io(codec, 1, 0);
+			}*/
+			break;
+
+		case SOUND_MIXER_DEVMASK: /* give them the supported mixers */
+			val = s->i2s->output_mask | s->i2s->input_mask;
+			break;
+
+		case SOUND_MIXER_RECMASK: 
+			/* Arg contains a bit for each supported recording 
+			 * source */
+			val = s->i2s->input_mask;
+			break;
+
+		case SOUND_MIXER_STEREODEVS: 
+			/* Mixer channels supporting stereo */
+			val = s->i2s->output_mask;
+			break;
+
+		case SOUND_MIXER_CAPS:
+			val = SOUND_CAP_EXCL_INPUT;
+			break;
+
+		default: /* read a specific mixer */
+			i = _IOC_NR(cmd);
+
+			if (!supported_mixer(i))
+				return -EINVAL;
+
+			val = s->i2s->get_mixer(s->i2s, i);
+ 			break;
+		}
+		return put_user(val, (int *)arg);
+	}
+
+	if (_SIOC_DIR(cmd) == (_SIOC_WRITE|_SIOC_READ)) {
+		if (get_user(val, (int *)arg))
+			return -EFAULT;
+		switch (_IOC_NR(cmd)) {
+		case SOUND_MIXER_RECSRC: 
+			/* Arg contains a bit for each recording source */
+			if (!s->i2s->input_mask)
+				return -EINVAL;
+			if (!val)
+				return 0;
+
+			if (!(val &= s->i2s->input_mask))
+				return -EINVAL;
+			else 
+				s->i2s->set_recsrc(s->i2s, val);
+
+			return 0;
+		default: /* write a specific mixer */
+			i = _IOC_NR(cmd);
+
+			if (!supported_mixer(i))
+				return -EINVAL;
+
+			s->i2s->set_mixer(s->i2s, i, val);
+
+			return 0;
+	}
+}
+	return -EINVAL;
 }
 
-void
-codec_init(void)
+static loff_t
+au1550_llseek(struct file *file, loff_t offset, int origin)
 {
-	wrcodec(0x1e, 0x00);	/* Reset */
-	au1550_delay(200);
-	wrcodec(0x0c, 0x00);	/* Power up everything */
-	au1550_delay(10);
-	wrcodec(0x12, 0x00);	/* Deactivate codec */
-	au1550_delay(10);
-	wrcodec(0x08, 0x10);	/* Select DAC outputs to line out */
-	au1550_delay(10);
-	wrcodec(0x0a, 0x00);	/* Disable output mute */
-	au1550_delay(10);
-	wrcodec(0x05, 0x70);	/* lower output volume on headphone */
-	au1550_delay(10);
-	wrcodec(0x0e, 0x02);	/* Set slave, 16-bit, I2S modes */
-	au1550_delay(10);
-	wrcodec(0x10, 0x01);	/* 12MHz (USB), 250fs */
-	au1550_delay(10);
-	wrcodec(0x12, 0x01);	/* Activate codec */
-	au1550_delay(10);
+	return -ESPIPE;
 }
 
+static /*const */ struct file_operations au1550_mixer_fops = {
+	owner:THIS_MODULE,
+	llseek:au1550_llseek,
+	ioctl:au1550_ioctl_mixdev,
+	open:au1550_open_mixdev,
+	release:au1550_release_mixdev,
+};
+
+
+
 /* stop the ADC before calling */
 static void
 set_adc_rate(struct au1550_state *s, unsigned rate)
 {
-	struct dmabuf  *adc = &s->dma_adc;
 	struct dmabuf  *dac = &s->dma_dac;
+	struct dmabuf  *adc = &s->dma_adc;
+	unsigned adcr=rate, dacr=dac->sample_rate;
+
 
-	if (s->no_vra) {
+#ifndef try_srcfacor
+	adcr = dacr = rate;
+#endif
+	s->i2s->set_rates(s->i2s, &adcr, &dacr);
+	
+#ifdef try_srcfacor
+	if ( adcr != rate ) {
 		/* calc SRC factor
 		*/
-		adc->src_factor = (((SAMP_RATE*2) / rate) + 1) >> 1;
-		adc->sample_rate = SAMP_RATE / adc->src_factor;
-		return;
+		adc->src_factor = ((96000 / rate) + 1) >> 1;
+		adc->sample_rate = adcr / adc->src_factor;
+	} else {
+		adc->src_factor = 1;
+		adc->sample_rate = adcr;
 	}
 
-	adc->src_factor = 1;
-
-
-#if 0
-	rate = rate > SAMP_RATE ? SAMP_RATE : rate;
-
-	wrcodec(0, 0);	/* I don't yet know what to write here if we vra */
+	/* Check to see if changing ADC rate had effect on DAC rate */
+	if ( dacr != dac->sample_rate ) {
+		/* calc SRC factor
+		*/
+		dac->src_factor = ((96000 / dac->sample_rate) + 1) >> 1;
+		dac->sample_rate = dacr / dac->src_factor;
+	}
+	printk("-----------------------------------------\n");
+	printk("dacr %d Hz adcr %d Hz\n", dacr, adcr);
+	printk("dac_srcfactor %d adc_srcfactor %d\n", dac->src_factor, adc->src_factor );
+	printk("-----------------------------------------\n");
 
-	adc->sample_rate = rate;
-	dac->sample_rate = rate;
 #endif
+	adc->sample_rate = adcr;
+	dac->sample_rate = dacr;
+	dac->src_factor = adc->src_factor = 1;
 }
 
 /* stop the DAC before calling */
@@ -285,25 +382,43 @@
 {
 	struct dmabuf  *dac = &s->dma_dac;
 	struct dmabuf  *adc = &s->dma_adc;
+	unsigned adcr=adc->sample_rate, dacr=rate;
 
-	if (s->no_vra) {
+#ifndef try_srcfacor
+	adcr = dacr = rate;
+#endif
+	s->i2s->set_rates(s->i2s, &adcr, &dacr);
+
+#ifdef try_srcfacor
+	if ( dacr != rate ) {
 		/* calc SRC factor
 		*/
-		dac->src_factor = (((SAMP_RATE*2) / rate) + 1) >> 1;
-		dac->sample_rate = SAMP_RATE / dac->src_factor;
-		return;
+		dac->src_factor = ((96000 / rate) + 1) >> 1;
+		dac->sample_rate = dacr / dac->src_factor;
+	} else {
+		dac->src_factor = 1;
+		dac->sample_rate = dacr;
 	}
 
-	dac->src_factor = 1;
-
-#if 0
-	rate = rate > SAMP_RATE ? SAMP_RATE : rate;
+	/* Check to see if changing DAC rate had effect on ADC rate */
+	if ( adcr != adc->sample_rate ) {
+		/* calc SRC factor
+		*/
+		adc->src_factor = ((96000 / adc->sample_rate) + 1) >> 1;
+		adc->sample_rate = adcr / adc->src_factor;
+	}
 
-	wrcodec(0, 0);	/* I don't yet know what to write here if we vra */
+	printk("-----------------------------------------\n");
+	printk("dacr %d Hz adcr %d Hz\n", dacr, adcr);
+	printk("dac_srcfactor %d adc_srcfactor %d\n", dac->src_factor, adc->src_factor );
+	printk("-----------------------------------------\n");
 
-	adc->sample_rate = rate;
-	dac->sample_rate = rate;
 #endif
+
+	adc->sample_rate = adcr;
+	dac->sample_rate = dacr;
+	dac->src_factor = adc->src_factor = 1;
+
 }
 
 static void
@@ -311,29 +426,16 @@
 {
 	struct dmabuf  *db = &s->dma_dac;
 	unsigned long   flags;
-	uint	stat;
-	volatile psc_i2s_t *ip;
 
 	if (db->stopped)
 		return;
 
-	ip = s->psc_addr;
 	spin_lock_irqsave(&s->lock, flags);
 
-	ip->psc_i2spcr = PSC_I2SPCR_TP;
-	au_sync();
-
-	/* Wait for Transmit Busy to show disabled.
-	*/
-	do {
-		stat = ip->psc_i2sstat;
-		au_sync();
-	} while ((stat & PSC_I2SSTAT_TB) != 0);
-
+	i2s_stop_xmit(s->i2s);
 	au1xxx_dbdma_reset(db->dmanr);
 
 	db->stopped = 1;
-
 	spin_unlock_irqrestore(&s->lock, flags);
 }
 
@@ -342,29 +444,16 @@
 {
 	struct dmabuf  *db = &s->dma_adc;
 	unsigned long   flags;
-	uint	stat;
-	volatile psc_i2s_t *ip;
 
 	if (db->stopped)
 		return;
 
-	ip = s->psc_addr;
 	spin_lock_irqsave(&s->lock, flags);
 
-	ip->psc_i2spcr = PSC_I2SPCR_RP;
-	au_sync();
-
-	/* Wait for Receive Busy to show disabled.
-	*/
-	do {
-		stat = ip->psc_i2sstat;
-		au_sync();
-	} while ((stat & PSC_I2SSTAT_RB) != 0);
-
+	i2s_stop_recv(s->i2s);
 	au1xxx_dbdma_reset(db->dmanr);
 
 	db->stopped = 1;
-
 	spin_unlock_irqrestore(&s->lock, flags);
 }
 
@@ -390,19 +479,14 @@
 {
 	struct dmabuf  *db = &s->dma_dac;
 	unsigned long   flags;
-	volatile psc_i2s_t *ip;
 
 	if (!db->stopped)
 		return;
 
 	spin_lock_irqsave(&s->lock, flags);
 
-	ip = s->psc_addr;
 	set_xmit_slots(db->num_channels);
-	ip->psc_i2spcr = PSC_I2SPCR_TC;
-	au_sync();
-	ip->psc_i2spcr = PSC_I2SPCR_TS;
-	au_sync();
+	i2s_start_xmit(s->i2s);
 
 	au1xxx_dbdma_start(db->dmanr);
 
@@ -416,7 +500,6 @@
 {
 	struct dmabuf  *db = &s->dma_adc;
 	int	i;
-	volatile psc_i2s_t *ip;
 
 	if (!db->stopped)
 		return;
@@ -431,14 +514,9 @@
 			db->nextIn -= db->dmasize;
 	}
 
-	ip = s->psc_addr;
 	set_recv_slots(db->num_channels);
 	au1xxx_dbdma_start(db->dmanr);
-	ip->psc_i2spcr = PSC_I2SPCR_RC;
-	au_sync();
-	ip->psc_i2spcr = PSC_I2SPCR_RS;
-	au_sync();
-
+	i2s_start_recv(s->i2s);
 	db->stopped = 0;
 }
 
@@ -463,7 +541,6 @@
 	if (db->num_channels == 1)
 		db->cnt_factor *= 2;
 	db->cnt_factor *= db->src_factor;
-
 	db->count = 0;
 	db->dma_qcount = 0;
 	db->nextIn = db->nextOut = db->rawbuf;
@@ -502,15 +579,6 @@
 
 	db->dmasize = db->dma_fragsize * db->numfrag;
 	memset(db->rawbuf, 0, bufs);
-
-#ifdef AU1000_VERBOSE_DEBUG
-	dbg("rate=%d, samplesize=%d, channels=%d",
-	    rate, db->sample_size, db->num_channels);
-	dbg("fragsize=%d, cnt_factor=%d, dma_fragsize=%d",
-	    db->fragsize, db->cnt_factor, db->dma_fragsize);
-	dbg("numfrag=%d, dmasize=%d", db->numfrag, db->dmasize);
-#endif
-
 	db->ready = 1;
 	return 0;
 }
@@ -537,21 +605,14 @@
 {
 	struct au1550_state *s = (struct au1550_state *) dev_id;
 	struct dmabuf  *db = &s->dma_dac;
-	u32	i2s_stat;
-	volatile psc_i2s_t *ip;
 
-	ip = s->psc_addr;
-	i2s_stat = ip->psc_i2sstat;
-#ifdef AU1000_VERBOSE_DEBUG
-	if (i2s_stat & (PSC_I2SSTAT_TF | PSC_I2SSTAT_TR | PSC_I2SSTAT_TF))
-		dbg("I2S status = 0x%08x", i2s_stat);
-#endif
+//	i2s_status(s->i2s);
 	db->dma_qcount--;
 
 	if (db->count >= db->fragsize) {
-		if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
-							db->fragsize) == 0) {
-			err("qcount < 2 and no ring room!");
+		if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut, db->fragsize) == 0)
+		{
+			err("qcount < MIN_Q_COUNT and no ring room!");
 		}
 		db->nextOut += db->fragsize;
 		if (db->nextOut >= db->rawbuf + db->dmasize)
@@ -606,65 +667,43 @@
 
 }
 
-static loff_t
-au1550_llseek(struct file *file, loff_t offset, int origin)
-{
-	return -ESPIPE;
-}
-
-
-#if 0
-static int
-au1550_open_mixdev(struct inode *inode, struct file *file)
-{
-	file->private_data = &au1550_state;
-	return 0;
-}
-
-static int
-au1550_release_mixdev(struct inode *inode, struct file *file)
-{
-	return 0;
-}
-
-static int
-mixdev_ioctl(struct ac97_codec *codec, unsigned int cmd,
-                        unsigned long arg)
-{
-	return codec->mixer_ioctl(codec, cmd, arg);
-}
-
-static int
-au1550_ioctl_mixdev(struct inode *inode, struct file *file,
-			       unsigned int cmd, unsigned long arg)
-{
-	struct au1550_state *s = (struct au1550_state *)file->private_data;
-	struct ac97_codec *codec = s->codec;
-
-	return mixdev_ioctl(codec, cmd, arg);
-}
-
-static /*const */ struct file_operations au1550_mixer_fops = {
-	owner:THIS_MODULE,
-	llseek:au1550_llseek,
-	ioctl:au1550_ioctl_mixdev,
-	open:au1550_open_mixdev,
-	release:au1550_release_mixdev,
-};
-#endif
-
 static int
 drain_dac(struct au1550_state *s, int nonblock)
 {
 	unsigned long   flags;
 	int             count, tmo;
 
+	struct dmabuf  *db = &s->dma_dac;
+
+	//DPRINTF();
 	if (s->dma_dac.mapped || !s->dma_dac.ready || s->dma_dac.stopped)
 		return 0;
 
 	for (;;) {
 		spin_lock_irqsave(&s->lock, flags);
-		count = s->dma_dac.count;
+		count = db->count;
+
+		/* Pad the ddma buffer with zeros if the amount remaining 
+		 * is not a multiple of fragsize */
+		if(count % db->fragsize != 0)
+		{
+			int pad = db->fragsize - (count % db->fragsize);
+			char* bufptr = db->nextIn;
+			char* bufend = db->rawbuf + db->dmasize;
+
+			if((bufend - bufptr) < pad)
+				printk("Error!  ddma padding is bigger than available ring space!\n");
+			else
+			{
+				memset((void*)bufptr, 0, pad);
+				count += pad;
+				db->nextIn += pad;
+				db->count += pad;
+				if (db->dma_qcount == 0)
+						start_dac(s);
+				db->dma_qcount++;
+			}
+		}
 		spin_unlock_irqrestore(&s->lock, flags);
 		if (count <= 0)
 			break;
@@ -672,13 +711,15 @@
 			break;
 		if (nonblock)
 			return -EBUSY;
-		tmo = 1000 * count / (s->no_vra ?
-				      SAMP_RATE : s->dma_dac.sample_rate);
+		tmo = 1000 * count / ((s->dma_dac.src_factor!=1) ?
+				      s->i2s->sr : s->dma_dac.sample_rate);
+//		tmo = 1000 * count / s->dma_dac.sample_rate;
 		tmo /= s->dma_dac.dma_bytes_per_sample;
 		au1550_delay(tmo);
 	}
 	if (signal_pending(current))
 		return -ERESTARTSYS;
+
 	return 0;
 }
 
@@ -698,8 +739,7 @@
  *     If interpolating (no VRA), duplicate every audio frame src_factor times.
  */
 static int
-translate_from_user(struct dmabuf *db, char* dmabuf, char* userbuf,
-							       int dmacount)
+translate_from_user(struct dmabuf *db, char* dmabuf, char* userbuf, int dmacount)
 {
 	int             sample, i;
 	int             interp_bytes_per_sample;
@@ -737,11 +777,12 @@
 
 		/* duplicate every audio frame src_factor times
 		*/
-		for (i = 0; i < db->src_factor; i++)
+		for (i = 0; i < db->src_factor; i++) {
 			memcpy(dmabuf, dmasample, db->dma_bytes_per_sample);
+			dmabuf += interp_bytes_per_sample;
+		}
 
 		userbuf += db->user_bytes_per_sample;
-		dmabuf += interp_bytes_per_sample;
 	}
 
 	return num_samples * interp_bytes_per_sample;
@@ -996,15 +1037,14 @@
 		 * on the dma queue.  If the queue count reaches zero,
 		 * we know the dma has stopped.
 		 */
-		while ((db->dma_qcount < 2) && (db->count >= db->fragsize)) {
+		while ((db->dma_qcount < MIN_Q_COUNT) && (db->count >= db->fragsize)) {
 			if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
 							db->fragsize) == 0) {
-				err("qcount < 2 and no ring room!");
+				err("qcount < MIN_Q_COUNT and no ring room!");
 			}
 			db->nextOut += db->fragsize;
 			if (db->nextOut >= db->rawbuf + db->dmasize)
 				db->nextOut -= db->dmasize;
-			db->count -= db->fragsize;
 			db->total_bytes += db->dma_fragsize;
 			if (db->dma_qcount == 0)
 				start_dac(s);
@@ -1017,7 +1057,6 @@
 		buffer += usercnt;
 		ret += usercnt;
 	}			/* while (count > 0) */
-
 out:
 	up(&s->sem);
 out2:
@@ -1237,6 +1276,7 @@
 				if ((ret = prog_dmabuf_dac(s)))
 					return ret;
 		}
+
 		return put_user((file->f_mode & FMODE_READ) ?
 				s->dma_adc.sample_rate :
 				s->dma_dac.sample_rate,
@@ -1371,9 +1411,6 @@
 			s->dma_dac.cnt_factor;
 		abinfo.fragstotal = s->dma_dac.numfrag;
 		abinfo.fragments = abinfo.bytes >> s->dma_dac.fragshift;
-#ifdef AU1000_VERBOSE_DEBUG
-		dbg("bytes=%d, fragments=%d", abinfo.bytes, abinfo.fragments);
-#endif
 		return copy_to_user((void *) arg, &abinfo,
 				    sizeof(abinfo)) ? -EFAULT : 0;
 
@@ -1536,13 +1573,9 @@
 	case SNDCTL_DSP_SETSYNCRO:
 	case SOUND_PCM_READ_FILTER:
 		return -EINVAL;
+	default: break;
 	}
-
-#if 0
-	return mixdev_ioctl(s->codec, cmd, arg);
-#else
 	return 0;
-#endif
 }
 
 
@@ -1664,54 +1697,11 @@
 MODULE_AUTHOR("Advanced Micro Devices (AMD), dan@embeddededge.com");
 MODULE_DESCRIPTION("Au1550 Audio Driver");
 
-/* Set up an internal clock for the PSC3.  This will then get
- * driven out of the Au1550 as the master.
- */
-static void
-intclk_setup(void)
-{
-	uint	clk, rate, stat;
-
-	/* Wire up Freq4 as a clock for the PSC3.
-	 * We know SMBus uses Freq3.
-	 * By making changes to this rate, plus the word strobe
-	 * size, we can make fine adjustments to the actual data rate.
-	 */
-	rate = get_au1x00_speed();
-#ifdef TRY_441KHz
-	rate /= (11 * 1000000);
-#else
-	rate /= (12 * 1000000);
-#endif
-
-	/* The FRDIV in the frequency control is (FRDIV + 1) * 2
-	*/
-	rate /=2;
-	rate--;
-	clk = au_readl(SYS_FREQCTRL1);
-	au_sync();
-	clk &= ~(SYS_FC_FRDIV4_MASK | SYS_FC_FS4);;
-	clk |= (rate << SYS_FC_FRDIV4_BIT);
-	clk |= SYS_FC_FE4;
-	au_writel(clk, SYS_FREQCTRL1);
-	au_sync();
-
-	/* Set up the clock source routing to get Freq4 to PSC3_intclk.
-	*/
-	clk = au_readl(SYS_CLKSRC);
-	au_sync();
-	clk &= ~0x01f00000;
-	clk |= (6 << 22);
-	au_writel(clk, SYS_CLKSRC);
-	au_sync();
-}
 
 static int __devinit
 au1550_probe(void)
 {
 	struct au1550_state *s = &au1550_state;
-	int             val;
-	volatile psc_i2s_t *ip;
 #ifdef AU1550_DEBUG
 	char            proc_str[80];
 #endif
@@ -1724,14 +1714,7 @@
 	init_MUTEX(&s->open_sem);
 	spin_lock_init(&s->lock);
 
-
-	s->psc_addr = (volatile psc_i2s_t *)I2S_PSC_BASE;
-	ip = s->psc_addr;
-
-	if (!request_region(PHYSADDR(ip),
-			    0x30, AU1550_MODULE_NAME)) {
-		err("I2S Audio ports in use");
-	}
+	s->i2s = i2s_hw_init(); 
 
 	/* Allocate the DMA Channels
 	*/
@@ -1759,17 +1742,15 @@
 		goto err_dma2;
 	}
 
+	info("%s CODEC", s->i2s->name );
 	info("DAC: DMA%d, ADC: DMA%d", DBDMA_I2S_TX_CHAN, DBDMA_I2S_RX_CHAN);
 
 	/* register devices */
-
 	if ((s->dev_audio = register_sound_dsp(&au1550_audio_fops, -1)) < 0)
 		goto err_dev1;
-#if 0
-	if ((s->codec->dev_mixer =
-	     register_sound_mixer(&au1550_mixer_fops, -1)) < 0)
+
+	if ((s->dev_mixer = register_sound_mixer(&au1550_mixer_fops, -1)) < 0)
 		goto err_dev2;
-#endif
 
 #ifdef AU1550_DEBUG
 	/* intialize the debug proc device */
@@ -1777,86 +1758,10 @@
 				       proc_au1550_dump, NULL);
 #endif /* AU1550_DEBUG */
 
-	intclk_setup();
-
-	/* The GPIO for the appropriate PSC was configured by the
-	 * board specific start up.
-	 *
-	 * configure PSC for I2S Audio
-	 */
-	ip->psc_ctrl = PSC_CTRL_DISABLE;	/* Disable PSC */
-	au_sync();
-	ip->psc_sel = (PSC_SEL_CLK_INTCLK | PSC_SEL_PS_I2SMODE);
-	au_sync();
-
-	/* Enable PSC
-	*/
-	ip->psc_ctrl = PSC_CTRL_ENABLE;
-	au_sync();
-
-	/* Wait for PSC ready.
-	*/
-	do {
-		val = ip->psc_i2sstat;
-		au_sync();
-	} while ((val & PSC_I2SSTAT_SR) == 0);
-
-	/* Configure I2S controller.
-	 * Deep FIFO, 16-bit sample, DMA, make sure DMA matches fifo size.
-	 * Actual I2S mode (first bit delayed by one clock).
-	 * Master mode (We provide the clock from the PSC).
-	 */
-	val = PSC_I2SCFG_SET_LEN(16);
-#ifdef TRY_441KHz
-	/* This really should be 250, but it appears that all of the
-	 * PLLs, dividers and so on in the chain shift it.  That's the
-	 * problem with sourceing the clock instead of letting the very
-	 * stable codec provide it.  But, the PSC doesn't appear to want
-	 * to work in slave mode, so this is what we get.  It's  not
-	 * studio quality timing, but it's good enough for listening
-	 * to mp3s.
-	 */
-	val |= PSC_I2SCFG_SET_WS(252);
-#else
-	val |= PSC_I2SCFG_SET_WS(250);
-#endif
-	val |= PSC_I2SCFG_RT_FIFO8 | PSC_I2SCFG_TT_FIFO8 | \
-					PSC_I2SCFG_BI | PSC_I2SCFG_XM;
-
-	ip->psc_i2scfg = val;
-	au_sync();
-	val |= PSC_I2SCFG_DE_ENABLE;
-	ip->psc_i2scfg = val;
-	au_sync();
-
-	/* Wait for Device ready.
-	*/
-	do {
-		val = ip->psc_i2sstat;
-		au_sync();
-	} while ((val & PSC_I2SSTAT_DR) == 0);
-
-	val = ip->psc_i2scfg;
-	au_sync();
-
-	codec_init();
-
-	s->no_vra = 1;
-	if (s->no_vra)
-		info("no VRA, interpolating and decimating");
-
-#if 0
-	/* set mic to be the recording source */
-	val = SOUND_MASK_MIC;
-	mixdev_ioctl(s->codec, SOUND_MIXER_WRITE_RECSRC,
-		     (unsigned long) &val);
-#ifdef AU1550_DEBUG
-	sprintf(proc_str, "driver/%s/%d/ac97", AU1550_MODULE_NAME,
-		s->codec->id);
-	s->ac97_ps = create_proc_read_entry (proc_str, 0, NULL,
-					     ac97_read_proc, &s->codec);
-#endif
-#endif
+	/* Initial settings for sample rates */
+	s->dma_dac.sample_rate = s->dma_adc.sample_rate = 8000;
+	set_adc_rate(s, 8000);  //Set default rate
+	set_dac_rate(s, 8000);  //Set default rate
 
 	return 0;
 
@@ -1866,12 +1771,14 @@
  err_dev2:
 	unregister_sound_dsp(s->dev_audio);
 #endif
+ err_dev2:
+	unregister_sound_dsp(s->dev_audio);
  err_dev1:
 	au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
  err_dma2:
 	au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
  err_dma1:
-	release_region(PHYSADDR(I2S_PSC_BASE), 0x30);
+	i2s_hw_cleanup(s->i2s);
 
 	return -1;
 }
@@ -1890,7 +1797,7 @@
 	synchronize_irq();
 	au1xxx_dbdma_chan_free(s->dma_adc.dmanr);
 	au1xxx_dbdma_chan_free(s->dma_dac.dmanr);
-	release_region(PHYSADDR(I2S_PSC_BASE), 0x30);
+	i2s_hw_cleanup(s->i2s);
 	unregister_sound_dsp(s->dev_audio);
 #if 0
 	unregister_sound_mixer(s->codec->dev_mixer);
diff -Nur linux-2.4.30/drivers/sound/au1550_i2s.h linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s.h
--- linux-2.4.30/drivers/sound/au1550_i2s.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,131 @@
+/*
+ *      au1550_i2s_hw.c  --  Sound driver support for AMD Alchemy 
+ *   			Au1550/Au1200 MIPS Processor Cores
+ *
+ */
+
+#ifndef _AU1550_I2S_H
+#define _AU1550_I2S_H
+
+#if defined(CONFIG_MIPS_PB1200)
+	#include <asm/pb1200.h>
+	#define WM8731
+#endif
+
+#if defined(CONFIG_MIPS_DB1200)
+	#include <asm/db1200.h>
+	#define WM8731
+#endif
+
+#if defined(CONFIG_MIPS_PB1550)
+	#include <asm/pb1550.h>
+	#define WM8731
+#endif
+
+#if defined(CONFIG_MIPS_DB1550)
+	#include <asm/db1x00.h>
+	#define WM8731
+#endif
+
+#if defined(CONFIG_MIPS_FICMMP)
+	#include <asm/ficmmp.h>
+	#define WM8721
+#endif
+
+
+#define AU1XXX_MODULE_NAME "Au1xxx i2s audio"
+#define PFX AU1XXX_MODULE_NAME
+
+#define err(format, arg...) printk(KERN_ERR PFX ": " format "\n" , ## arg)
+#define info(format, arg...) printk(KERN_INFO PFX ": " format "\n" , ## arg)
+
+#define supported_mixer(FOO) ((FOO >= 0) && \
+                                    (FOO < SOUND_MIXER_NRDEVICES) && \
+                                    (s->i2s->input_mask | s->i2s->output_mask) & (1<<FOO) )
+
+
+struct i2s_hw {
+	char *name;
+	int	  codec_is_master;
+	int   input_mask;
+	int   output_mask;
+	volatile psc_i2s_t *psc;
+	unsigned int sr;
+	void  (*codec_init)(struct i2s_hw *hw);
+	void  (*wrcodec)(u8 ctlreg, u16 val);
+	int   (*set_rates)(struct i2s_hw *hw, u32 *in, u32 *out);
+	int   (*get_mixer)(struct i2s_hw *hw, u16 oss_channel);
+	void  (*set_mixer)(struct i2s_hw *hw, u16 oss_channel, u16 val);
+	void  (*set_recsrc)(struct i2s_hw *hw, int src);
+};
+
+/* Prototypes */
+struct i2s_hw * i2s_hw_init(void);
+void i2s_hw_cleanup(struct i2s_hw *hw);
+
+/* Helper functions */
+static inline void i2s_stop_xmit(struct i2s_hw *hw)
+{
+	volatile psc_i2s_t *ip = hw->psc;
+	u32 stat;
+
+	ip->psc_i2spcr = PSC_I2SPCR_TP;
+	au_sync();
+
+	/* Wait for Transmit Busy to show disabled.
+	*/
+	do {
+		stat = ip->psc_i2sstat;
+		au_sync();
+	} while ((stat & PSC_I2SSTAT_TB) != 0);
+}	
+	
+static inline void i2s_stop_recv(struct i2s_hw *hw)
+{
+	volatile psc_i2s_t *ip = hw->psc;
+	u32 stat;
+
+	ip->psc_i2spcr = PSC_I2SPCR_RP;
+	au_sync();
+
+	/* Wait for Transmit Busy to show disabled.
+	*/
+	do {
+		stat = ip->psc_i2sstat;
+		au_sync();
+	} while ((stat & PSC_I2SSTAT_RB) != 0);
+}	
+
+static inline void i2s_start_xmit(struct i2s_hw *hw)
+{
+	volatile psc_i2s_t *ip = hw->psc;
+	ip->psc_i2spcr = PSC_I2SPCR_TC;
+	au_sync();
+	ip->psc_i2spcr = PSC_I2SPCR_TS;
+	au_sync();
+}
+
+static inline void i2s_start_recv(struct i2s_hw *hw)
+{
+	volatile psc_i2s_t *ip = hw->psc;
+	ip->psc_i2spcr = PSC_I2SPCR_RC;
+	au_sync();
+	ip->psc_i2spcr = PSC_I2SPCR_RS;
+	au_sync();
+}
+
+static inline unsigned i2s_status(struct i2s_hw *hw)
+{
+	volatile psc_i2s_t *ip = hw->psc;
+	u32	i2s_stat;
+
+	i2s_stat = ip->psc_i2sstat;
+#ifdef AU1000_VERBOSE_DEBUG
+	if (i2s_stat & (PSC_I2SSTAT_TF | PSC_I2SSTAT_TR | PSC_I2SSTAT_TF))
+		dbg("I2S status = 0x%08x", i2s_stat);
+#endif
+
+	return(i2s_stat);
+}
+
+#endif
